/*
 * Copyright  2008 Nokia Corporation.
 */



#ifndef __LOCALIZATIONAPPUI_H__
#define __LOCALIZATIONAPPUI_H__

// INCLUDES
#include <aknappui.h>
//#include <aknutils.h>

// FORWARD DECLARATIONS
class CLocalizationAppView;


// CLASS DECLARATION
/**
* CLocalizationAppUi application UI class.
* Interacts with the user through the UI and request message processing
* from the handler class
*/
class CLocalizationAppUi : public CAknAppUi
    {
    public: // Constructors and destructor

        /**
        * ConstructL.
        * 2nd phase constructor.
        */
        void ConstructL();

        /**
        * CLocalizationAppUi.
        * C++ default constructor. This needs to be public due to
        * the way the framework constructs the AppUi
        */
        CLocalizationAppUi();

        /**
        * ~CLocalizationAppUi.
        * Virtual Destructor.
        */
        virtual ~CLocalizationAppUi();

    private:  // Functions from base classes

        /**
        * From CEikAppUi, HandleCommandL.
        * Takes care of command handling.
        * @param aCommand Command to be handled.
        */
        void HandleCommandL( TInt aCommand );

//        void HandleResourceChangeL(TInt aType);
        

    private: // Data

        /**
        * The application view
        * Owned by CLocalizationAppUi
        */
        CLocalizationAppView* iAppView;
        
    };

#endif // __LOCALIZATIONAPPUI_H__

// End of File